<?php
if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

global $template;
$template->set_filenames( array('plugin_admin_content' => dirname(__FILE__).'/administration.tpl') );

/**
 * Reading plugin's configuration
 */
include_once('include/config.inc.php');

// Simulation mode ?
$simulate = FALSE;
if (isset($_POST['simulate']))
  $simulate = ($_POST['simulate'] == 1 ? TRUE : FALSE);

if (isset($_POST['posted']) && isset($_POST['htaccess_action'])) {
  include_once('include/htaccess_generation.inc.php');
  global $page;
  $result = array();

  /** START: CONFIGURATION SETTINGS **/

  // Storing the type of .htaccess that was selected for the creation if NOT in simulation mode
  if (!$simulate)
    $cfg_obj->set('htaccess_type', $_POST['htaccess_type']);

  // Storing the list of extensions that should not be handled
  // mysql_escape_string is used for safety reasons because the array will be later used for a sql query
  $excluded_file_types = isset($_POST['file_types']) ? 
                          array_map("mysql_escape_string", $_POST['file_types']) :
                          array(); 
  $cfg_obj->set('exclude_extensions', $excluded_file_types);

  // Storing extra content for .htaccess files
  if (isset($_POST['htaccess_extra_content']))
    $cfg_obj->set('htaccess_extra_content', $_POST['htaccess_extra_content']);

  // Storing maximum filesize information
  if (isset($_POST['max_file_size_value']))
    $cfg_obj->set('max_file_size_value', floatval($_POST['max_file_size_value']));
  if (isset($_POST['max_file_size_unit']))
    $cfg_obj->set('max_file_size_unit', $_POST['max_file_size_unit']);

  // Storing choice regarding access to protected thumbnails representing public categories
  $temp_bool = isset($_POST['unhandle_representatives']);
  $cfg_obj->set('allow_rep_thumbs', $temp_bool);

  // Committing changes made to configuration options
  $cfg_obj->store_config();

  /** END: CONFIGURATION SETTINGS **/

  // What must we do, create or remove the .htaccess files ?
  switch ($_POST['htaccess_action']) {
    case 'create':
      $result = secureImages_htaccess_creation($_POST['htaccess_type'], $simulate);
      break;
    case 'remove':
      $result = secureImages_htaccess_removal($simulate);
      break;
    default:
      array_push($page['errors'], 'Please select the type of action: creation or removal of .htaccess files.');
  }

  foreach ($result['infos'] as $elt_infos)
    array_push($page['infos'], $elt_infos['path'].' '.$elt_infos['info']);

  foreach ($result['errors'] as $elt_errors)
    array_push($page['errors'], '['.$elt_errors['path'].'] '.
                $elt_errors['type'].
                ' ('.$secureImages_error_labels[$elt_errors['type']][0].
                ')'
              );
}

$query = '
  SELECT id,name,uppercats,global_rank
  FROM '.CATEGORIES_TABLE.';';

display_select_cat_wrapper($query,
    array(),
    'categories',
    false);

// Assigning template variables
  // Type of .htaccess
$template->assign_var('SECUREIMAGES_TYPE_IS_SELECTIVE', $cfg_obj->get('htaccess_type') == 'selective' ? 'checked' : '');
$template->assign_var('SECUREIMAGES_TYPE_IS_COMPLETE', $cfg_obj->get('htaccess_type') == 'complete' ? 'checked' : '');
  // Extra content for .htaccess files
$template->assign_var('SECUREIMAGES_HTACCESS_EXTRA', $cfg_obj->get('htaccess_extra_content'));
  // Allow access to private thumbnails for representing public categories
$template->assign_var('SECUREIMAGES_CHECK_UNHANDLE_REPRESENTATIVES', $cfg_obj->get('allow_rep_thumbs') ? 'checked' : '');
  // Do not handle files bigger than a certain value
$template->assign_var('SECUREIMAGES_TEXT_MAX_FILE_SIZE_VALUE', $cfg_obj->get('max_file_size_value'));
$template->assign_var('SECUREIMAGES_TEXT_MAX_FILE_SIZE_UNIT_IS_'.$cfg_obj->get('max_file_size_unit'), 'selected="selected"');


/**
 * Preparing file_types select
 */
$excluded_file_types =& $cfg_obj->get('exclude_extensions');
$query = '
  SELECT DISTINCT(tn_ext)
  FROM '.IMAGES_TABLE.';';

$result = pwg_query($query);
if (!empty($result)) {
  global $template;

  while ($row = mysql_fetch_assoc($result)) {
    $template->assign_block_vars(
      'file_types',
      array('SELECTED' => in_array($row['tn_ext'], $excluded_file_types) ? 'selected="selected"' : '',
            'VALUE' => $row['tn_ext'],
            'OPTION' => $row['tn_ext']
           )
    );
  }
}

$template->assign_var('SECUREIMAGES_F_ACTION', $my_url);
$template->assign_var_from_handle( 'ADMIN_CONTENT', 'plugin_admin_content');

?>
